using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using CleverComponents.InetSuite;
using CleverComponents.InetSuite.Sspi;

namespace ClientSSL
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox edtServer;
		private System.Windows.Forms.TextBox edtPort;
		private System.Windows.Forms.TextBox edtData;
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.Button btnDisconnect;
		private System.Windows.Forms.Button btnSend;
		private System.Windows.Forms.TextBox memResponse;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			client = new SslClient();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.edtServer = new System.Windows.Forms.TextBox();
			this.edtPort = new System.Windows.Forms.TextBox();
			this.btnConnect = new System.Windows.Forms.Button();
			this.btnDisconnect = new System.Windows.Forms.Button();
			this.edtData = new System.Windows.Forms.TextBox();
			this.btnSend = new System.Windows.Forms.Button();
			this.memResponse = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Server";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(40, 23);
			this.label2.TabIndex = 1;
			this.label2.Text = "Port";
			// 
			// edtServer
			// 
			this.edtServer.Location = new System.Drawing.Point(64, 16);
			this.edtServer.Name = "edtServer";
			this.edtServer.Size = new System.Drawing.Size(168, 20);
			this.edtServer.TabIndex = 2;
			this.edtServer.Text = "localhost";
			// 
			// edtPort
			// 
			this.edtPort.Location = new System.Drawing.Point(64, 40);
			this.edtPort.Name = "edtPort";
			this.edtPort.Size = new System.Drawing.Size(64, 20);
			this.edtPort.TabIndex = 3;
			this.edtPort.Text = "9002";
			// 
			// btnConnect
			// 
			this.btnConnect.Location = new System.Drawing.Point(248, 16);
			this.btnConnect.Name = "btnConnect";
			this.btnConnect.TabIndex = 6;
			this.btnConnect.Text = "Connect";
			this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
			// 
			// btnDisconnect
			// 
			this.btnDisconnect.Location = new System.Drawing.Point(248, 48);
			this.btnDisconnect.Name = "btnDisconnect";
			this.btnDisconnect.TabIndex = 7;
			this.btnDisconnect.Text = "Disconnect";
			this.btnDisconnect.Click += new System.EventHandler(this.btnDisconnect_Click);
			// 
			// edtData
			// 
			this.edtData.Location = new System.Drawing.Point(16, 88);
			this.edtData.Name = "edtData";
			this.edtData.Size = new System.Drawing.Size(216, 20);
			this.edtData.TabIndex = 8;
			this.edtData.Text = "Sample data";
			// 
			// btnSend
			// 
			this.btnSend.Location = new System.Drawing.Point(248, 88);
			this.btnSend.Name = "btnSend";
			this.btnSend.TabIndex = 9;
			this.btnSend.Text = "Send";
			this.btnSend.Click += new System.EventHandler(this.btnSend_Click);
			// 
			// memResponse
			// 
			this.memResponse.Location = new System.Drawing.Point(0, 128);
			this.memResponse.Multiline = true;
			this.memResponse.Name = "memResponse";
			this.memResponse.ReadOnly = true;
			this.memResponse.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.memResponse.Size = new System.Drawing.Size(344, 144);
			this.memResponse.TabIndex = 10;
			this.memResponse.Text = "";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(344, 270);
			this.Controls.Add(this.memResponse);
			this.Controls.Add(this.btnSend);
			this.Controls.Add(this.edtData);
			this.Controls.Add(this.btnDisconnect);
			this.Controls.Add(this.btnConnect);
			this.Controls.Add(this.edtPort);
			this.Controls.Add(this.edtServer);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "Form1";
			this.Text = "SSL Client";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(new ExceptionHandler().OnThreadException);
			Application.Run(new Form1());
		}

		private SslClient client;

		private void btnConnect_Click(object sender, System.EventArgs e) {
			if(client.Active)
				throw new Exception("Client already connected");

			client.Server = edtServer.Text;
			client.Port = Convert.ToInt32(edtPort.Text);
			client.TimeOut = 10000;

			//is necessary when using self-signed certificate by server
			client.CertificateFlags = CertificateVerifyFlags.IgnoreCommonNameInvalid
				| CertificateVerifyFlags.IgnoreUnknownAuthority;

			//specifies TLS 1.0 protocols (also available SSL 2.0 and SSL 3.0)
			client.TlsFlags = TlsFlags.UseTLS;

			//forces the component to start SSL negotiation immediately once connecting
			client.UseTls = ClientTlsMode.Implicit;

			client.Open();

			this.Text = "SSL Client - Connected";
		}

		private void btnDisconnect_Click(object sender, System.EventArgs e) {
			client.Close();
			this.Text = "SSL Client";
		}

		private void btnSend_Click(object sender, System.EventArgs e) {
			lock(this) {
				using(StringStream stream = new StringStream(edtData.Text)) {
					client.SendData(stream);

					stream.SetLength(0);
					client.ReceiveData(stream);
					memResponse.Text += "Received from server: " + stream.DataString + "\r\n";
				}
			}
		}
	}

	public class ExceptionHandler {
		public void OnThreadException(object sender, System.Threading.ThreadExceptionEventArgs t) {
			MessageBox.Show(t.Exception.Message);
		}
	}
}
