using System;
using System.IO;
using CleverComponents.InetSuite;

namespace ClientSSL {
	public class SslClient : TcpClient {
		protected override int GetDefaultPort() {
			return 9002;
		}

		public void SendData(Stream data) {
			Connection.WriteData(data);
		}

		public void ReceiveData(Stream data) {
			using(Stream stream = new MemoryStream()) {
				//read size of incoming data
				while(stream.Length < 8) {
					Connection.ReadData(stream);
				}
				stream.Position = 0;
				byte[] buf = new byte[8];
				stream.Read(buf, 0, buf.Length);
				long len = BitConverter.ToUInt32(buf, 0);

				//copy the first block of data
				if(stream.Length > buf.Length) {
					StreamUtils.Copy(stream, data, stream.Length - buf.Length);
				}

				//receive remaining data from server
				while(data.Length < len) {
					Connection.ReadData(data);
				}
			}
		}
	}
}
