using System;
using System.IO;
using CleverComponents.InetSuite;

namespace ServerSSL {
	public class SslCommandConnection : UserConnection {}

	public class SslServer : TcpServer {
		protected override UserConnection CreateDefaultConnection() {
			return new SslCommandConnection();
		}

		protected override void OnConnectionRead(ConnectionDataEventArgs e) {
			if(e.Data.Length == 0)
				return;

			base.OnConnectionRead(e);

			//send the size of data to the client
			using(Stream stream = new MemoryStream()) {
				byte[] buf = BitConverter.GetBytes(e.Data.Length);

				stream.Write(buf, 0, buf.Length);
				stream.Position = 0;
				e.Connection.WriteData(stream);
			}

			//send data to the client
			e.Data.Position = 0;
			e.Connection.WriteData(e.Data);
		}
	}
}
